;=====================================================================
;
; Author:        blueb (Bob Houle)
; Date:           Feb 27, 2015
; Explain:        I got tired of reducing each JPG photo in my storage folders one at a time...
;                    so I made simple bulk program to shrink my JPG files For emailing, etc.
;           
; Usage:         Choose a folder, it will add a sub-folder (Small Images) and insert the shrunken files into it.
;
; Note:           Uses freeware: JPGconv.exe  (c)2005 Balthasar Indermuehle ... see the included Readme file
;=====================================================================
EnableExplicit

Enumeration
  #WinMain
  #imgLogo
  #txtNext
  #txtSource
  #txtTarget
  #strboxSource
  #strboxSmallFolder
  #btnChoosePath
  #btnQuit
  #btnCompress
  #txtInformation
  #Logo
  #WriteInfoToLog
  #ReadFromLog
  #txtCopyRight
  #TrackBar
  #txtTrackBarValueBox
  #txtTrackBarMessageDisplay
  #txtTrackBarValueDisplay
EndEnumeration

DataSection 
  Image1:
  IncludeBinary "JPG Shrink.bmp"
EndDataSection


Global Path$, TrackValue.i

Define.l Event, EventWindow, EventGadget, EventType, Result, Quit

Declare Readlog() 

; =======================================================================================================================
If OpenWindow(#WinMain, 391, 91, 510, 420, "JPG Compression Program", #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_TitleBar|#PB_Window_ScreenCentered)

  If LoadFont(1, "Arial", 11) 
      SetGadgetFont(#PB_Default, FontID(1))
      ImageGadget(#imgLogo, 5, 0, 500, 130, CatchImage(#Logo, ?Image1))

      TextGadget(#txtTrackBarMessageDisplay, 10, 130, 345, 20, "Compresses JPGs from: 10% to 90% of original")
      SetGadgetColor(#txtTrackBarMessageDisplay, #PB_Gadget_FrontColor, $228B22)
 
      TrackBarGadget(#TrackBar, 5, 150, 505, 20, 10, 90, #PB_TrackBar_Ticks)
      SetGadgetState(#TrackBar, 50) ; set as the default value
      
      TrackValue = GetGadgetState(#TrackBar)
      TextGadget(#txtTrackBarValueDisplay, 390, 130, 110, 20, "Now set to: " + Str(TrackValue) +"%")
      SetGadgetColor(#txtTrackBarValueDisplay, #PB_Gadget_FrontColor, $228B22)
 
      TextGadget(#txtNext, 10, 180 , 300, 20, "Next - Select your JPG Picture Folder...")
      SetGadgetColor(#txtNext, #PB_Gadget_FrontColor, $228B22)
      
      TextGadget(#txtSource, 25, 180 + 32, 86, 20, "Source Folder:", #PB_Text_Right)
      TextGadget(#txtTarget, 25, 180 + 55, 86, 20, "Target Folder:", #PB_Text_Right)
      SetGadgetColor(#txtSource, #PB_Gadget_FrontColor, $228B22)
      SetGadgetColor(#txtTarget, #PB_Gadget_FrontColor, $228B22)
      
      StringGadget(#strboxSource, 115, 180+ 30, 315, 20, "Button selects a folder ---->",#PB_String_ReadOnly)
      SetGadgetColor(#strboxSource, #PB_Gadget_FrontColor,  $0007FC)
      StringGadget(#strboxSmallFolder, 115,180 + 55, 315, 20,"",#PB_String_ReadOnly)
      SetGadgetColor(#strboxSmallFolder, #PB_Gadget_FrontColor, $C9C9CD) 
      ButtonGadget(#btnChoosePath, 445, 180 +27, 50, 25, "...")
      TextGadget(#txtInformation, 75, 180 + 90, 350, 55, "Copies your originals, then creates reduced versions in your 'Small Images' sub-folder." + #CRLF$  + "Note: Your originals are safe!", #PB_Text_Center)

      SetGadgetColor(#txtInformation, #PB_Gadget_FrontColor,  $228B22)
      TextGadget(#txtCopyRight, 10, 400, 300, 20, "Uses Balthasar Indermuehle's Resizer Tool")
      SetGadgetColor(#txtCopyRight, #PB_Gadget_FrontColor,  $228B22)
      ButtonGadget(#btnQuit, 410, 385, 90, 30, "Quit")
      SetGadgetColor(#btnQuit, #PB_Gadget_FrontColor,$0007FC)
      ButtonGadget(#btnCompress, 100, 180 + 150, 315, 40, "I will Compress then Open the Folder")
      
      Readlog()
      HideGadget(#btnCompress, 1)
   EndIf
    
EndIf
;=====================================================================
 Procedure GetFileList(StartDir.s,List Lfiles.s(),pattern.s="*.*", Recursive=1) ; Recursive switch
; ------------------------------------------------------------------------------------------------------------------------------
; Author:      Idle 
; Date:           October 24th, 2012
; Explain:
;           
; Typical Usage:       GetFileList("C:\GetBack\BackupFolder",myfiles(),"*.*",0)  ; Get all files in the directory   
; ------------------------------------------------------------------------------------------------------------------------------

Protected mDir, Directory.s, Filename.s, FullFileName.s, tdir.s, ct, a, depth
   
   Static NewList Lpattern.s()
   Static bset,FileCount
     
   If Not bset
      pattern = RemoveString(pattern,"*.")
      ct = CountString(pattern,"|") + 1
      ClearList(lpattern())
      For a = 1 To ct
           AddElement(Lpattern())
           Lpattern() = UCase(StringField(pattern,a,"|"))
       Next
       bset=1
    ElseIf depth = 0
       bset = 0
    EndIf
 
  mDir = ExamineDirectory(#PB_Any, StartDir, "*.*")
  If mDir
    While NextDirectoryEntry(mDir)
      If DirectoryEntryType(mDir) = #PB_DirectoryEntry_File
          Directory = startdir
          FileName.s = DirectoryEntryName(mDir)
           ForEach Lpattern()
                 If lpattern() = "*" Or GetExtensionPart(UCase(FileName)) = lpattern()
                     FullFileName.s = StartDir + "\" + FileName
                     AddElement(LFiles())
                     Lfiles() = FullFileName
                  FileCount+1
               EndIf
            Next 
      Else
         tdir = DirectoryEntryName(mDir)
              If tdir <> "." And tdir <> ".."
                      If Recursive = 1
                         depth + 1
                      GetFileList(startDir + "\" + tdir,LFiles(),Pattern,Recursive)
                     EndIf
              EndIf
      EndIf
    Wend
    FinishDirectory(mDir)
  EndIf
   
  ProcedureReturn FileCount

EndProcedure
; =====================================================================
Procedure Convert()
     
Protected DirectoryName$, OriginalPath$, OrignalFilename$, OriginalFullName$, RenamedFile$
Protected RenamedFullName$, NewNamedFile$, Parameter$, SourceDirectory$, Pattern$, DestinationDirectory$
Protected JPGQuality.s, PercentOfOriginal.s
Protected Result.i, RenameFileCount.i, SmallFileCount.i 

NewList myfiles.s()
     
   ; #1 - Create "Small Images" Directory as a sub-directory of the user's folder
   DirectoryName$ = GetGadgetText(#strboxSmallFolder)
   Result = CreateDirectory(DirectoryName$)
   
   ; #2 - Get Path and fileNames
        OriginalPath$ = GetGadgetText(#strboxSource)  
       
     If GetFileList(Path$, myfiles(),"*.jpg",0)  ; get all the JPG files in this directory
             RenameFileCount = 1
             SmallFileCount = 1
             ForEach myfiles()
                 OrignalFilename$ = GetFilePart(myfiles())  ;strip filename out
                 
                 ; a) Make a temporary copy of the file (to preserve the original)
                        ;  will need full paths for CopyFile()
                           OriginalFullName$ = OriginalPath$ +OrignalFilename$
                           RenamedFile$ = "Re_" + Str(RenameFileCount) +".jpg" ; this gets by the need for DOS file length requirement of JPGconv.exe
                           RenamedFullName$ = OriginalPath$ + RenamedFile$
                           CopyFile(OriginalFullName$, RenamedFullName$)
                           Delay (250)
                           
                 ; b) Compress each Re_Named file
                           
                        ;   See Balthasar Indermuehle's Readme.txt file in the included source folder.
                        ;   jpgconv.exe <infile> <outfile> [<jpg quality> <resize> <silent> [<"text"> <font> <size> <color> <bgcolor> <x> <y> <bold> <italic> <underline>]]
                           NewNamedFile$ = "Sm_"+ Str(SmallFileCount) +".jpg"
                           JPGQuality.s = "80" ; seems like a decent compromise
                           PercentOfOriginal.s = Str(TrackValue) + "%"
                        
                           Parameter$ = RenamedFile$ + " "+ NewNamedFile$ + " " + JPGQuality + " " +  PercentOfOriginal + " " + "s" ;(s = silent)
                           Result = RunProgram("JPGconv.exe", Parameter$, Path$, #PB_Program_Hide)
                           Delay(150)
                           
           ; Increment the temporary file counters
             RenameFileCount + 1
             SmallFileCount + 1
             
            Next 
            Delay (150) ;Allow a little time for completion
            
   ; #3 - Erase all the Re_x.jpg files
                  SourceDirectory$ = GetGadgetText(#strboxSource)
                  Pattern$ = "Re_*.jpg"
                  Result = DeleteDirectory(SourceDirectory$, Pattern$)
                  Delay (500) ; Allow a little time for DeleteDirectory completion
                  
   ; # 4 - Move all the 'Sm_x.jpg' files to '\Small Images' folder
                    SourceDirectory$ = GetGadgetText(#strboxSource)
                    DestinationDirectory$ = GetGadgetText(#strboxSmallFolder)
                    Pattern$ = "Sm_*.jpg"
                    Result = CopyDirectory(SourceDirectory$, DestinationDirectory$, Pattern$)
                    Delay (500) ; Allow a little time for CopyDirectory completion
                    
            ; Next delete Image files in 'Main' folder                    
                    Result = DeleteDirectory(SourceDirectory$, Pattern$)
                    Delay (250) ; Allow a little time for DeleteDirectory completion
                    
            ; Open folder to view the Image files in '\Small Images\' sub folder
                    ; makes this program Windows only... sorry
                    ShellExecute_(0, "Open", DestinationDirectory$, #NUL, #NUL, #SW_RESTORE)      
                    FreeList(myfiles.s()) ; Free the filenames list
  EndIf 
   
EndProcedure
; =====================================================================
Procedure writelog(log.s) 
     Protected Result.i
  ; First delete the log file to assure current info
     Result = DeleteFile("User.log")

    OpenFile(#WriteInfoToLog,"User.log") 
    FileSeek(#WriteInfoToLog,Lof(#WriteInfoToLog)) 
    WriteStringN(#WriteInfoToLog,log.s) 
    CloseFile(#WriteInfoToLog)  
EndProcedure
; =====================================================================
Procedure Readlog() 
     
    If ReadFile(#ReadFromLog, "User.log")         
          Path$ = ReadString(#ReadFromLog)       
          SetGadgetText(#strboxSource, Path$)
          SetGadgetText(#strboxSmallFolder, Path$ + "Small Images")
          CloseFile(#ReadFromLog)              
      Else
        MessageRequester("Information","User.log NOT found... created a new file!")
      EndIf

EndProcedure 
; =====================================================================

; Events
Repeat
  Event = WaitWindowEvent()
  Select Event
    ; ------------------------------
    Case #PB_Event_Gadget
      EventGadget = EventGadget()
      EventType = EventType()
      
          If EventGadget = #btnChoosePath ; Path Button
                  Path$ = PathRequester("Please choose your path", Path$)
                  SetGadgetText(#strboxSource, Path$)
                ; Change the text of Compress button
                  SetGadgetText(#btnCompress, "I will Compress then Open the Folder")
                  DisableGadget(#btnCompress, 0)
                      ;Remember this location
                      writelog(Path$)
                 
                  SetGadgetColor(#strboxSource, #PB_Gadget_FrontColor, $C9C9CD) 
                  SetGadgetText(#strboxSmallFolder, Path$ + "Small Images")
                  HideGadget(#btnCompress, 0)
                  
          ElseIf EventGadget = #TrackBar ; TrackBar slider control
                 ;get the Trackbar value                  
                  TrackValue = GetGadgetState(#TrackBar)
                  SetGadgetText(#txtTrackBarValueDisplay, "Now set at " + Str(TrackValue) +"%")
                  
          ElseIf EventGadget = #btnQuit ; Quit Button
                   Quit = 1
             
          ElseIf EventGadget = #btnCompress ; Compress Button
                  ; Change the text
                    SetGadgetText(#btnCompress, "Working...Patience Please!")
                  ; Disable the button until user chooses to use new Path
                    DisableGadget(#btnCompress, 1)
                    SetCursor_(LoadCursor_(#Null, #IDC_WAIT))
                    ShowCursor_(#True)
                    Convert() ; procedure that does the whole task
                  ; Change the text
                    SetGadgetText(#btnCompress, "Choose another folder if you wish to continue")  
             
          EndIf
    ; ---------------------------------------
    Case #PB_Event_CloseWindow
           EventWindow = EventWindow()
           If EventWindow = #WinMain
             CloseWindow(#WinMain)
             Break
           EndIf
  EndSelect
  
Until Quit = 1

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 262
; FirstLine = 266
; Folding = -
; EnableXP
; UseIcon = COMPRES1.ICO
; Executable = JPG Compressor.exe